package edu.udo.cs.ie.cowbots.bdi.desgen;

import java.util.List;

/**
 * Interface for any class representing an agents
 * motiveset. The motiveset consists of a list of
 * IMotive objects, each representing a unique 
 * motive and used to generate new desires. 
 * 
 * @author dhoelzgen
 *
 */
public interface IMotiveSet extends List<IMotive> {

}
