package edu.udo.cs.ie.cowbots.elpParser.dlp;

/**
 * let constants, variables and lists of mix(variable, constants, comparative operator, arithmetic operator)
 * like a term to act.
 * 
 * @author Sebastian, Wei
 *
 */

public interface DLPTerm {
	
	/**
	 * get variable or constant or operator back
	 * @return
	 */
	public String getName();	

	
	/**
	 * if this is operator or not
	 * @return
	 */
	public boolean isOperator();
	
	/**
	 *if this is arithmetic operator or not
	 *@return
	 */
	public boolean isArithOP();
	
	/**
	 *if this is comparative operator or not
	 *@return
	 */
	public boolean isCompOP();
	
}
