package edu.udo.cs.ie.cowbots.internalActions.Helper;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;


/**
 * 
 * @author Loewen
 * This internal action is called by a helper to check, if he is almost by leader
 * returns true or false 
 */
public class arrivedAtLeader extends DefaultInternalAction {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	//private static int DISTANCETOLEADER = 6;
	
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		
		int myX= (int) ((NumberTerm) args[0]).solve(); 
		int myY= (int) ((NumberTerm) args[1]).solve(); 
		int destX= (int) ((NumberTerm) args[2]).solve(); 
		int destY= (int) ((NumberTerm) args[3]).solve();
		int diffX = Math.abs(myX-destX);
		int diffY = Math.abs(myY-destY);
		int diff= Math.max(diffX, diffY);
		un.unifies(args[4], new NumberTermImpl(diff));
		return true;
	}	
	
	
}
