package edu.udo.cs.ie.cowbots.internalActions.experimental;

import java.util.ArrayList;
import java.util.List;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import edu.udo.cs.ie.cowbots.internalActions.scout.createWaypoints;
import edu.udo.cs.ie.cowbots.logic.ELPLiteral;
import edu.udo.cs.ie.cowbots.util.GridMap;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.Message;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.Atom;
import jason.asSyntax.Literal;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;

public class exCreateWaypoints extends DefaultInternalAction {

	/**
	 * Called to test waypoint mechanism, returns the number
	 * of generated waypoints.
	 */
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		createWaypoints waypoints = new createWaypoints();
		waypoints.experimental_obstacle = false; // TODO: Sometimes causes very strange behavior...
		return waypoints.execute(ts, un, args);
	}
}
