package edu.udo.cs.ie.cowbots.internalActions.scout;

import edu.udo.cs.ie.cowbots.agent.ICowbot;
import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.NumberTerm;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.Term;

public class checkDestValidity extends DefaultInternalAction{
	int tX;
	int tY;
	int valid;
	
	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
	throws Exception {
		try {
			tX = (int) ((NumberTerm) args[0]).solve();
			tY = (int) ((NumberTerm) args[1]).solve();
			String cellContent =((ICowbot) ts.getAg()).getEpistemicState().getMap().getContent(tX, tY).getAtom().getTerm(0).toString();
			
			valid = checkValidity(cellContent);
			return un.unifies(args[2], new NumberTermImpl(valid));
			
		}catch(Throwable e){
			System.out.println("check Dest: " + e);
			e.printStackTrace();
		}
		return false;
	}
	private int checkValidity(String cellContent)
	{
		
		if(cellContent.equals("empty") | cellContent.equals("unexplored") ) return 1;
		else return 0;
	}

}
