package edu.udo.cs.ie.cowbots.logic;

/**
 * private class to model arithmetic expressions
 * like "A = B + C".
 * @author Thomas
 *
 */
class ArithmeticPredicate extends ELPAtom {
	
	public ArithmeticPredicate(String pred, String ...terms) {
		super(pred, terms);
	}
	
	public String toString() {
		return terms[2] + "=" + terms[0] + pred + terms[1];
	}
	
	@Override
	public boolean isArithmetic() {
		return true;
	}
	
	@Override
	public boolean isPredicate() {
		return true;
	}
}