package edu.udo.cs.ie.cowbots.logic;

import java.util.ArrayList;

/**
 * This class models declarations used within a K-program,
 *  which are the fluent and the action declarations. 
 *  Needed to type fluents and actions to the background predicates.
 * 
 * @author      Elly
 */


public class KDeclaration {
	
	ELPAtom atom;
	ArrayList<ELPAtom> types;
	
	
	public KDeclaration (ELPAtom atom, ArrayList<ELPAtom> types){
		this.atom = atom;
	    this.types = types;
		
	}
	
	
	public String toString(){
		String ret = "";
		ret += atom.toString();
		if (types.size() > 0){
			ret += " requires ";
			for (int i=0; i< types.size(); i++){
				ret += types.get(i).toString();
				if (i<types.size()-1){
					ret += ", ";
				} else{
					ret += ".";
				}
			}	
		return ret;
		}
		ret += ".";
		return ret;
	}
	
	

}
