package edu.udo.cs.ie.cowbots.planer;

import java.util.Stack;
import java.util.StringTokenizer;

import edu.udo.cs.ie.cowbots.agent.CowbotAgent;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.IntendedMeans;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;

import jason.asSyntax.Literal;
import jason.asSyntax.NumberTermImpl;
import jason.asSyntax.PlanBody;
import jason.asSyntax.PlanBodyImpl;
import jason.asSyntax.StringTermImpl;
import jason.asSyntax.Term;
import jason.asSyntax.PlanBody.BodyType;

/**
 * 
 * Java methods to get Intensity for current Goal (lastgoal)
 * 
 * @author Michael, Alex
 *
 */

public class getIntensityForLastGoal extends DefaultInternalAction {

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
		
		CowbotAgent agent = (CowbotAgent)ts.getAg();
		int intensity=agent.getCowDelib().getLastGoal().getIntensity();
		un.unifies(new NumberTermImpl(intensity), args[0]);
		return true;
	}

	
}


