package edu.udo.cs.ie.cowbots.util;

/**
 * basic cell for a massim scenario, mainly used for the
 * contest version of the mas.
 * 
 * @author Thomas
 *
 * @param <T>
 */
public class GridCell<T> {
	public GridCell() {
		cell_content = null;
		cell_type = null;
		cell_flag = null;
		has_mover = false;
		
		isObstacle = false;		// flag indicating if field is an obstacle
		isSwitch = false;		// flag indicating if field is a switch
		isAgent = false;		// flag indicating if field is an agent
		isCow = false;			// flag indicating if field is a cow
		isClosed = false;		// flag indicating if field is a closed switch
		isUnexplored = false;	// flag that indicates an 
	}
	
	// for moving ison types
	public T	cell_content;
	// for cell type at all (unexplored by default)
	public T	cell_type;	 
	// for stuff isopen, etc
	public T	cell_flag;
	
	public boolean has_mover;
	
	public boolean isObstacle;
	
	public boolean isSwitch;
	
	public boolean isFence;
	
	public boolean isAgent;
	
	public boolean isCow;
	
	public boolean isClosed;
	
	public boolean isUnexplored;
	
	public T	get(int i) {
		if (i == 0)
			return cell_content;
		if (i == 1)
			return cell_type;
		if (i == 2)
			return cell_flag;
		return null;
	}
	
	public T	set(int i, T t) {
		T ret = null;
		if (i == 0) {
			ret = cell_content;
			cell_content = t;
		}
		if (i == 1) {
			ret = cell_type;
			cell_type = t;
		}
		if (i == 2) {
			ret = cell_flag;
			cell_flag = t;
		}
		return ret;
	}
	
	/*
	public boolean isObstacle() {
		return hintObs;
	}
	
	public boolean isSwitch() {
		return hintSwitch();
	}
	
	public boolean isFence() {
		return hintFence();
	}
	*/
}
