{include ("shared_knowledge.asl")}
{include ("scoutWalker.asl")}
//debug.

//Scout Agent - Cowbots
+dummyEvent:true
<-
	true.

/* Plans */
+!scouted : true  
<- !debugPrint("Im in: scouted : true");
   !multiAgentTask(scouting).

+!multiAgentTask(scouting) :  true 
	<- !debugPrint("Im in: multiAgentTask(scouting) :  true ");
	   !scoutGroupFormed;
	   !scoutTaskDecomposition;
	   !foreachWaypoint;
	   !cleanBeliefs.
	   

+!foreachWaypoint: planFailed
<- 
.print("abolish plan in foreachWP");
!abolishPlan.   


+!foreachWaypoint : waypointCounter(I) & wayPoints(W) & I < W 
<- !debugPrint("Im in: !foreachWaypoint : waypointCounter(I) & wayPoints(W) & I < W ");
	   !scoutTaskAllocation;
	   //!scoutPlanned;
	   //!problemSolved;
	   !executedMonitored;
	   ?waypointCounter(I);
	   -+waypointCounter(I+1);
	   !foreachWaypoint;
	   .wait(100).
	   

+!foreachWaypoint : not wayPoints(_)
<-!debugPrint("Im in: foreachWaypoint : not wayPoints(_)");
  .wait(100);
  !foreachWaypoint.
 
+!foreachWaypoint : true
<-!debugPrint("Im in: foreachWaypoint : true");
   true.


//GroupFormed
+!scoutGroupFormed : not iWantToScout(_,_)[source(self)]
<-  !debugPrint("Im in: scoutGroupFormed : not iWantToScout(_,_)[source(self)]");
	?iam(N);
    ?ison(N,AX,AY,_);
    +iWantToScout(AX,AY);
    .broadcast(tell, iWantToScout(AX,AY));
	skip;
	!scoutGroupFormed.

+!scoutGroupFormed : iWantToScout(_,_)[source(self)] & (iWantToScout(_,_)[source(S)] &  S \== self)
<-	
  !debugPrint("Im in: scoutGroupFormed : iWantToScout(_,_)[source(self)]");
  ?iam(N);
  edu.udo.cs.ie.cowbots.internalActions.scout.checkPriority(N,A);
  +imHighPriority(A);
  .wait(100);
  !buildScoutPair.

+!scoutGroupFormed : true
<-
  .wait(100);
  !scoutGroupFormed.

+!buildScoutPair :  imHighPriority(1) & not myVassal & not (iWantToScout(_,_)[source(S)] &  S \== self)
<- !debugPrint("Im in: buildScoutPair :  imHighPriority(1) & not myVassal & not (iWantToScout(_,_)[source(S)]");
   ?iam(N);
   //.print("I have no partner QQ ups i am " , N);
   .wait(1000);
   !buildScoutPair.

+!buildScoutPair :  imHighPriority(1) & not myVassal & (iWantToScout(_,_)[source(S)] &  S \== self)
<- !debugPrint("Im in: buildScoutPair :  imHighPriority(1) & not myVassal & (iWantToScout(_,_)[source(S)] ");
   ?iam(N);
   edu.udo.cs.ie.cowbots.internalActions.scout.selectPartner(N,ID);
  .send(ID, tell, myLord);
  .wait(100);
  !buildScoutPair.

+!buildScoutPair :  imHighPriority(1) & myVassal
<- !debugPrint("Im in: buildScoutPair :  imHighPriority(1) & myVassal");
	!completeGroup.

+!buildScoutPair : imHighPriority(0) & not myLord
<- !debugPrint("Im in: buildScoutPair : imHighPriority(0) & not myLord");
   -imHighPriority(_);
   ?iam(N);
   edu.udo.cs.ie.cowbots.internalActions.scout.checkPriority(N,A);
   +imHighPriority(A);
   //.print("Im in buildScoutPair Prio  and my name is ",N);
   .wait(100);
   !buildScoutPair.

+!buildScoutPair : imHighPriority(0) & myLord & not cleanPrep
<- !debugPrint("Im in: !buildScoutPair : imHighPriority(0) & myLord & not cleanPrep");
   ?myLord[source(Y)];
   .send(Y, tell, myVassal);
   .wait(100);
   !buildScoutPair.

+!buildScoutPair : imHighPriority(0) & myLord & cleanPrep
<- !debugPrint("Im in: buildScoutPair : imHighPriority(0) & myLord & cleanPrep");
   ?myLord[source(Y)];
   ?iam(N);
   ?ison(N,AX,AY,_);
   .broadcast(untell, iWantToScout(AX,AY));
   -iWantToScout(AX,AY);
   -cleanPrep[source(Y)];
   -imHighPriority(0);
   .wait(100).


+!completeGroup : true
 <-   !debugPrint("Im in: completeGroup : true");
   ?myVassal[source(Y)];
   .send(Y,tell, cleanPrep);
   ?iam(N);
   ?ison(N,AX,AY,_);
   .broadcast(untell, iWantToScout(AX,AY));
   -iWantToScout(AX,AY);
   -imHighPriority(1);
   .wait(100).
   

  //Get candidates and the best(weighted) destination. Context world is known
+!scoutTaskDecomposition : worldknown & myVassal & (not scoutDestination(_,_)[source(self)])
	<-
	    edu.udo.cs.ie.cowbots.internalActions.scout.getRandomScoutCandidate(X,Y);
	   !verifyCandidate(X,Y).

 //Get candidates and the best(weighted) destination. Context world not known
+!scoutTaskDecomposition : (not worldknown) & myVassal & (not scoutDestination(_,_)[source(self)])
	<-
	   !debugPrint("Im in: scoutTaskDecomposition : (not worldknown) & myVassal & (not scoutDestination(_,_)[source(self)])");
	    edu.udo.cs.ie.cowbots.internalActions.scout.getScoutCandidate(X,Y);
	   !verifyCandidate(X,Y).

+!scoutTaskDecomposition : myLord[source(S)] & not scoutDestination(_,_)[source(S)] 
	<-!debugPrint("Im in: scoutTaskDecomposition : myLord[source(S)] & not scoutDestination(_,_)[source(S)] ");
	  // .print("Waiting for destination");
	   .wait(100);
	   !scoutTaskDecomposition.
	   
+!scoutTaskDecomposition : myLord[source(S)] & scoutDestination(_,_)[source(S)]  
<- !debugPrint("Im in: scoutTaskDecomposition : myLord[source(S)] & scoutDestination(_,_)[source(S)]  ");
   +waypointCounter(1).
  

+!scoutTaskDecomposition : myVassal & scoutDestination(_,_)[source(self)] 
<-!debugPrint("Im in: scoutTaskDecomposition : myVassal & scoutDestination(_,_)[source(self)] ");
  ?iam(O);
  ?scoutDestination(X,Y)[source(self)];
  edu.udo.cs.ie.cowbots.planer.makePlan(scouted,X,Y,O,T);
  +wayPoints(T);
  ?myVassal[source(Vassal)];
  .send(Vassal, tell , wayPoints(T)); 
  +waypointCounter(1).
  
  
//Verify candidates for destination	   
+!verifyCandidate(X,Y) : true  
	<- 	!debugPrint("Im in: verifyCandidate(X,Y) : true ");  
	   .broadcast(tell, scoutOption(X,Y));
	   +scoutOption(X,Y);
	    edu.udo.cs.ie.cowbots.internalActions.scout.checkScoutArea(X,Y,P);
       +areaAccepted(P);
       !addDestination(X,Y).
       
//If there is no conflict with other agents candidates, set destination = best candidate       
+!addDestination(X,Y) : areaAccepted(1)
	<- 	!debugPrint("Im in: addDestination(X,Y) : areaAccepted(1)");
	   +scoutDestination(X,Y);
	   -areaAccepted(1);
	   .broadcast(untell, scoutOption(X,Y));
	   .broadcast(tell, scoutDestination(X,Y));
	   -scoutOption(X,Y);
	   .wait(100);
	   !scoutTaskDecomposition.	   


//Ops, there is a conflict, discard candidate	   
+!addDestination(X,Y) : areaAccepted(0)
	<- !debugPrint("Im in: addDestination(X,Y) : areaAccepted(0)");
	   -areaAccepted(0);
	   .broadcast(untell, scoutOption(X,Y));
	   -scoutOption(X,Y);
	   .wait(100);
	   !scoutTaskDecomposition.


+!scoutTaskAllocation : myVassal 
<-!debugPrint("Im in: scoutTaskAllocation : myVassal");
 ?waypointCounter(I);
 ?kwaypoint(_,I,XW,YW,_,_);
 ?myVassal[source(Y)];
 .send(Y,tell, kwaypoint(1,I,XW,YW,1,1));
 .wait(100).
 
 
+!scoutTaskAllocation : myLord & not kwaypoint(_,_,_,_,_,_)
<-!debugPrint("Im in: scoutTaskAllocation : myLord & not kwaypoint(_,_,_,_,_,_)");
 .wait(100);
 !scoutTaskAllocation. 

+!scoutTaskAllocation : myLord & kwaypoint(_,_,_,_,_,_)
<-!debugPrint("Im in: scoutTaskAllocation : myLord & kwaypoint(_,_,_,_,_,_)");
  true.

+!scoutPlanned : true
<-!debugPrint("Im in: scoutPlanned : true");
  true.

+!executedMonitored : myVassal
<-!debugPrint("Im in: executedMonitored : myVassal");
  ?waypointCounter(I2);
  ?kwaypoint(_,I2,XW2,YW2,_,_);
  .wait(100);
  !walkToDest(XW2,YW2);  
  !waitForPartnerToArrive. 
  
+!executedMonitored : myLord
<-!debugPrint("Im in: executedMonitored : myLord");
  .wait(100);
  ?waypointCounter(I2);
  ?kwaypoint(_,I2,XW2,YW2,_,_);
  !walkToDest(XW2,YW2);
  !waitForPartnerToArrive. 
  
+!walkToDest(CX,CY) : true
<-!debugPrint("Im in: walkToDest(CX,CY) : true");
   !scoutWalkTo(CX,CY).
   
   
-!walkToDest(CX,CY) : myVassal
<-
   ?myVassal[source(Vassal)];
   .send(Vassal, tell, planFailed);
   !debugPrint("Im in: Fehler walkToDest(CX,CY) : true");
   !abolishPlan.
   
-!walkToDest(CX,CY) : myLord
<-
   ?myLord[source(Lord)];
   .send(Lord, tell, planFailed);
   !debugPrint("Im in: Fehler walkToDest(CX,CY) : true");
   !abolishPlan.
      
+!waitForPartnerToArrive: planFailed
<- 
   .print("abolish plan in waitForPartnerToArrive");
   !abolishPlan.   
      
      
+!waitForPartnerToArrive : myVassal & not sendSync  
<-!debugPrint("Im in: waitForPartnerToArrive : myVassal & not sendSync");
  ?myVassal[source(V)];
  .send(V, tell, waiting);
  +sendSync;
  .wait(100);
  !waitForPartnerToArrive.

+!waitForPartnerToArrive : myLord & not sendSync
<-!debugPrint("Im in: waitForPartnerToArrive : myLord & not sendSync");
   ?myLord[source(L)];
  .send(L, tell, waiting);
  +sendSync;
  .wait(100);
  !waitForPartnerToArrive.

+!waitForPartnerToArrive : myVassal & sendSync & not waiting
<- !debugPrint("Im in: waitForPartnerToArrive : myVassal & sendSync & not waiting");
  .wait(100);
 // .print("waiting....");
  !waitForPartnerToArrive.
  
+!waitForPartnerToArrive : myLord & sendSync & not waiting
<-!debugPrint("Im in: waitForPartnerToArrive : myLord & sendSync & not waiting");
  .wait(100);
 // .print("waiting....");
  !waitForPartnerToArrive.

+!waitForPartnerToArrive : myVassal & sendSync & waiting 
<-!debugPrint("Im in: waitForPartnerToArrive : myVassal & sendSync & waiting");
   ?myVassal[source(V)];
   -waiting[source(V)];
   -sendSync;
   .wait(100).

+!waitForPartnerToArrive : myLord & sendSync & waiting 
<-!debugPrint("Im in: waitForPartnerToArrive : myLord & sendSync & waiting ");
    ?myLord[source(L)];
   -kwaypoint(_,_,_,_,_,_)[source(L)];
   -waiting[source(L)];
   -sendSync;
   .wait(100).


+!cleanBeliefs : myVassal
<-!debugPrint("Im in: cleanBeliefs : myVassal");
  ?myVassal[source(V)];
  ?scoutDestination(DX,DY)[source(self)];
  .broadcast(untell, scoutDestination(DX,DY));
  -scoutDestination(_,_);
  -waypointCounter(_);
  -wayPoints(_);
  -myVassal[source(V)];
  skip.
  	   
	   
+!cleanBeliefs : myLord
<-!debugPrint("Im in: cleanBeliefs : myLord");
   ?myLord[source(L)];
  -scoutDestination(_,_)[source(L)];
  -waypointCounter(_);
  -wayPoints(_)[source(L)];
  -myLord[source(L)];
  skip.



+!abolishPlan : myLord
<-!debugPrint("Im in:abolishPlan : myLord");
  
  ?myLord[source(L)];
  -planFailed[source(L)];
  -kwaypoint(_,_,_,_,_,_)[source(L)];
  -waiting[source(L)];
  -sendSync;
  -iWantToScout(AX,AY)[source(self)];
  -imHighPriority(_);
  -scoutDestination(_,_)[source(L)];
  -waypointCounter(_);
  -wayPoints(_)[source(L)];
  -cleanPrep[source(L)];
  -myLord[source(L)];
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
   skip;
  .succeed_goal(scouted).

+!abolishPlan : myVassal
<-!debugPrint("Im in:abolishPlan : myVassal");
  
  ?myVassal[source(V)];
  -planFailed[source(V)];
  .abolish(kwaypoint(_,_,_,_,_,_));
  -waiting[source(V)];
  -sendSync;
  -iWantToScout(AX,AY)[source(self)];
  -imHighPriority(_);
  ?scoutDestination(DX,DY)[source(self)];
  .broadcast(untell, scoutDestination(DX,DY));
  -scoutDestination(_,_)[source(self)];
  -waypointCounter(_);
  -wayPoints(_);
  -myVassal[source(V)];
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
  skip;
  .succeed_goal(scouted).


-!abolishPlan: true
<- !debugPrint("Im in:abolishPlan : true");
  .abolish(kwaypoint(_,_,_,_,_,_));
  -sendSync;
  -iWantToScout(AX,AY)[source(self)];
  -imHighPriority(_);
  -scoutDestination(_,_)[source(self)];
  -waypointCounter(_);
  -wayPoints(_);
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
  .succeed_goal(scouted).


+!destructScout : true
<- !debugPrint("Im in:destructScout : true");
   !abolishPlan.


// HILFSFUNKTIONEN  -----------------------------------------------------------------------
+!dummyPlan : true
<-
  .wait(1000);
  !dummyPlan.
  
+!debugPrint(D): debug <-
      ?iam(MyName);
     .concat("ASL-DEBUG: Agent:",MyName," MSG: ",D,MSG);	
	.print(MSG).
+!debugPrint(D): not debug <- true.  
  
	   	    