//Initial beliefs
iAmNotBusy.
{include ("shared_knowledge.asl")}

+dummyEvent:true
<-
	true.

//Plans

+!scouted: true
<-
	.wait(500); 
	.print("scouting");
	!singleAgentTask(scouting).

-!scouted:true
<-
   
	.print("scouted ended mit fehler").

//Walk to destination(X,Y)
+!singleAgentTask(scouting) : scoutDestination(X,Y)[source(self)] & not destinationValid(_)
<- 
  edu.udo.cs.ie.cowbots.internalActions.scout.checkDestValidity(X,Y,C);
  +destinationValid(C).
  
+!singleAgentTask(scouting) : scoutDestination(X,Y)[source(self)] &  destinationValid(0)
<- 
   -scoutDestination(_,_)[source(self)];
   -destinationValid(0);
   .broadcast(untell,scoutDestination(_,_)).
  

//Walk to destination(X,Y)
+!singleAgentTask(scouting) : scoutDestination(X,Y)[source(self)] & destinationValid(1)  
<-
   -destinationValid(1);
   ?iam(N); 
   ?ison(N,X1,Y1,_);
   ?time(T);  
   edu.udo.cs.ie.cowbots.internalActions.scout.astar(X1,Y1,X,Y,A,T,0,0,0);
   A;
   .print("my destination: ",X,",",Y);
   
   ?ison(N,X2,Y2,_);
   edu.udo.cs.ie.cowbots.internalActions.scout.calculateDistanceToDestination(X2,Y2,X,Y,V);
   
   +tooNearTodestination(V);
   !considerDestinationdrop.
   
   
// considers whether the Agent is close enough to the destination to drop it, checked by the context.   
+!considerDestinationdrop: tooNearTodestination(1) 
<- 
   -scoutDestination(_,_)[source(self)];
   -tooNearTodestination(1);
   .broadcast(untell,scoutDestination(_,_)).

+!considerDestinationdrop: tooNearTodestination(0)
<-
  -tooNearTodestination(0).   
   


 //Get candidates and the best(weighted) destination. Context world is known
+!singleAgentTask(scouting) : ( worldknown & not scoutDestination(_,_)[source(self)])&(iAmNotBusy)
	<-
	   edu.udo.cs.ie.cowbots.internalActions.scout.getRandomScoutCandidate(X,Y);
	   !verifyCandidate(X,Y).


 //Get candidates and the best(weighted) destination. Context world not known
+!singleAgentTask(scouting) : ( not scoutDestination(_,_)[source(self)])&(iAmNotBusy)
	<-
	    edu.udo.cs.ie.cowbots.internalActions.scout.getScoutCandidate(X,Y);
	   !verifyCandidate(X,Y).
	   
//Verify candidates for destination	   
+!verifyCandidate(X,Y) : true  
	<- 	   
	   .broadcast(tell, scoutOption(X,Y));
	   +scoutOption(X,Y);
	    edu.udo.cs.ie.cowbots.internalActions.scout.checkScoutArea(X,Y,P);
       +permission(P);
       !addDestination(X,Y).
       
//If there is no conflict with other agents candidates, set destination = best candidate       
+!addDestination(X,Y) : permission(1)
	<- 
	   +scoutDestination(X,Y);
	   -permission(1);
	   .broadcast(untell, scoutOption(X,Y));
	   .broadcast(tell, scoutDestination(X,Y));
	   -scoutOption(X,Y).
//Ops, there is a conflict, discard candidate	   
+!addDestination(X,Y) : permission(0)
	<- -permission(0);
	   .broadcast(untell, scoutOption(X,Y));
	   -scoutOption(X,Y).
	   

	   