//Initial beliefs
{include ("ExAgents/exSharedKnowledge.asl")}
{include ("ExAgents/exScoutWalker.asl")}
//{include ("ExAgents/exHelper.asl")}
{include ("cbfunk.asl")}

//debug.

//Dummy event for dummy people 
+dummyEvent:true
<-
	!debugPrint("dummyEvent");
	.wait(100).

//Plans


+!scouted: myLastRole(MyRole) & MyRole \== scout
<-
    !debugPrint("im in scouted: myLastRole(MyRole) & MyRole unequal scout");
    !destruct(MyRole);
    -+myLastRole(scout).

//Main scout helper plan 
+!scouted: not wpoint(_, scouted, _, _, _, _, _, _, _, _, _)
<-
   !debugPrint("not waypoint: still waiting....QQ");
   ?iam(MyName); 
   !sendPosInfo(MyName);
   .wait(100).
   
  
+!scouted: wpoint(_, scouted, _, WC, XCOOR, YCOOR, FromDir, ToDir, _, _, _) & interwp(X,Y)
<- 
       !debugPrint("!scouted: wpoint(_,scouted,_,WC,XCOOR,YCOOR,_,_,_,_,_)");
       !walkToDest(X,Y);
       -interwp(_,_)[source(_)];
       .wait(100).
  
   
+!scouted: wpoint(fenceclosewp,scouted,_,WC,XCOOR,YCOOR,_,_,_,_,_)
<-
  !debugPrint("!scouted: wpoint(fenceclosewp,scouted,_,WC,XCOOR,YCOOR,_,_,_,_,_)");
  !walkToDest(XCOOR, YCOOR);
  .wait(100).
   

//Send the leader ACK for switch position
+!scouted: wpoint(scoutswitchoutside, scouted, _, WC, XCOOR, YCOOR, _, _, _, _, _) & iam(ME) & ison(ME,XCOOR,YCOOR,_) &  outsidesent
<-  !debugPrint("point(scoutswitch, scouted - erreicht + outsidesent");
   .wait(1000).

+!scouted: wpoint(scoutswitchoutside, scouted, _, WC, XCOOR, YCOOR, _, _, _, _, _) & iam(ME) & ison(ME,XCOOR,YCOOR,_)
<-
  !debugPrint("point(scoutswitch, scouted - erreicht");
  .print("At Switch!");
  ?iam(MyName);
  ?helper(LN, MyName,_);
  .send(LN, tell, fenceOpenOutside);
  +outsidesent;
  .wait(1000).
  
+!scouted: wpoint(scoutswitchinside, scouted, _, WC, XCOOR2, YCOOR2, _, _, _, _, _) & iam(ME) & ison(ME,XCOOR2,YCOOR2,_)  & insidesent  
<- !debugPrint("point(scoutswitchinside, scouted - erreicht + insidesent");
   .wait(1000).
  
+!scouted: wpoint(scoutswitchinside, scouted, _, WC, XCOOR2, YCOOR2, _, _, _, _, _) & iam(ME) & ison(ME,XCOOR2,YCOOR2,_)
<-
  !debugPrint("point(scoutswitchinside, scouted - erreicht");
  .print("At inner Switch!");
  ?iam(MyName);
  ?helper(LN, MyName,_);
  .send(LN, tell, fenceOpenInside);
  +insidesent;
  .wait(1000).  
  
  

+!scouted: wpoint(scoutswitchinside, scouted, _, WC, XCOOR, YCOOR, _, _, _, _, _)
<-
  !debugPrint("point(scoutswitchinside, scouted");
  !walkToDest(XCOOR, YCOOR); 
  .wait(100). 

//The helper is sent to the switch
+!scouted: wpoint(scoutswitchoutside, scouted, _, WC, XCOOR, YCOOR, _, _, _, _, _)
<-  !debugPrint("point(scoutswitch, scouted");
    !walkToDest(XCOOR, YCOOR); 
    .wait(100).
    
//The helper is searching for the switch
+!scouted: wpoint(findscoutswitch, scouted, _, WC, XCOOR, YCOOR, _, _, _, _, _)
<-  !debugPrint("wpoint(findscoutswitch,");
    !searchForSwitch(XCOOR, YCOOR); 
    .wait(100).
     
   
//Get the formation position for the current waypoint
+!scouted: wpoint(_, scouted, _, WC, XCOOR, YCOOR, FromDir, ToDir, _, _, _)
<-    
  !debugPrint("scouted: wpoint(_, scouted, _, WC, XCOOR, YCOOR, FromDir, ToDir, _, _, _)");
  ?iam(N);
  ?helper(_, N, C);
  edu.udo.cs.ie.cowbots.internalActions.experimental.exEasyFormation(XCOOR, YCOOR, C, FromDir, EXXCOOR, EXYCOOR);
  !walkToDest(EXXCOOR, EXYCOOR);
  .wait(100).

//Procedure for walking 
+!walkToDest(XC,YC) : true
<-
  !debugPrint("walkToDest(XC,YC) : true");
  !scoutWalkTo(XC, YC, 1).
  
  
-!walkToDest(XC,YC) : interwp(X,Y)
<-
  !debugPrint("-!walkToDest(XC,YC) : interwp");
  .succeed_goal(scouted).
 
+!searchForSwitch(XCOOR, YCOOR): true
 <- !debugPrint("searchForSwitch");
  !scoutWalkTo(XCOOR, YCOOR, 0).
  
-!searchForSwitch(XCOOR, YCOOR): true
 <- !debugPrint("-searchForSwitch");
    .succeed_goal(searchForSwitch(_,_)). 
  
  
//Failure event for plan walkToDest  
-!walkToDest(XC,YC) : true
<-
  !debugPrint("-!walkToDest(XC,YC) : true");
  .succeed_goal(walkToDest(_,_)).
  
  

//Event for new waypoint from the leader  
+waypoint(TYPE, scouted, _, WC, XCOOR, YCOOR, FromDir, ToDir, _, _, _) : true
<-
  !debugPrint("waypoint: true");
  .abolish(wpoint(_, _, _, _, _, _, _, _, _, _, _));
  .abolish(waypoint(_, _, _, _, _, _, _, _, _, _, _));
  +wpoint(TYPE, scouted, 0, WC, XCOOR, YCOOR, FromDir, ToDir, 0, 0, 0);
  -insidesent;
  -outsidesent;
  .succeed_goal(walkToDest(_,_,_)).
  
    
 
//Abolish all the beliefs, the plan has failed
+!abolishScoutedPlan : true
<-!debugPrint("Im in:abolishPlan ");
  .abolish(wpoint(_, _, _, _, _, _, _, _, _, _, _));
  .abolish(waypoint(_, _, _, _, _, _, _, _, _, _, _));
  -walkfailscount(_);
  +walkfailscount(0);
  -walkingfailed;
  -outsidesent;
  -insidesent;
  -interwp(_,_)[source(_)];
  .succeed_goal(walkToDest(_,_,_));
  .succeed_goal(scouted).

//Destructor for the scout role, invoke by other role
@desSc[atomic] +!destruct(scout) : true
<-
  !debugPrint("Im destructScout : true ");
  !abolishScoutedPlan.  