package edu.udo.cs.ie.cowbots.internalActions.math;

import java.util.List;
import java.util.ListIterator;

import jason.asSemantics.DefaultInternalAction;
import jason.asSemantics.TransitionSystem;
import jason.asSemantics.Unifier;
import jason.asSyntax.*;
/**
 * 
 * Java methods to make Helper and Rejected Lists
 * (AgentsList,GroupSize,HelperList,RejectedList);
 * @author Michael, Alex
 *
 */

public class roundToInt extends DefaultInternalAction {

	@Override
	public Object execute(TransitionSystem ts, Unifier un, Term[] args)
			throws Exception {
			
		float doubleValue = (float) ((NumberTerm) args[0]).solve();	
		int intValue=Math.round(doubleValue);		
		un.unifies(args[1], new NumberTermImpl(intValue));		
		return true;
	}

	
}


