package edu.udo.cs.ie.cowbots.logic;

/**
* This class models causation rules needed for DLV-K programs. 
*
* @author Elly
*/

import java.util.ArrayList;

/**
 * @author  Elly
 */
public class KCausationRule extends KRule {

	ELPLiteral caused;	

	
	public KCausationRule (ELPLiteral caused){
		this.caused = caused;
		ifPart = new ArrayList<ELPLiteral>();
		afterPart = new ArrayList<ELPLiteral>();
	}
	
	public KCausationRule (ELPLiteral caused, ArrayList<ELPLiteral> ifPart, ArrayList<ELPLiteral> afterPart){
		this.caused = caused;
		this.ifPart = ifPart;
		this.afterPart = afterPart;
	}
	
	/**
	 * @param caused  the caused to set
	 */
	public void setCaused(ELPLiteral caused) {
		this.caused = caused;
	}
	
	@Override
	public String toString(){
		String ret = "";
		if (!(ifPart.isEmpty())|| !(afterPart.isEmpty()))
			ret += "caused " + caused.toString();
		else 
			ret += caused.toString();
		ret += super.toString();
		
		return ret;
	}
	
}
