// Agent HELPER in project MAS
//todo evtl. die .wait auf source[leader] beschr�nken
/* Initial beliefs and rules */


/* Initial goals */


/* Plans */

+!helped(Leader, T, Cow):	T == drivencow       
      						& help(Task, Cow, Intensity, Time)[source(Leader)]   
      						& time(Wtime)
      						& not myLeader(_)
	<-	!debugPrint("Switched to Helper-Role!");
	   	.succeed_goal(scouted);
	   	//TODO: scouter abolish plan 
	   	//!abolishPlan;
       	.succeed_goal(drivencow(_));       
	   	?iam(MyName);
	   	!taskabortLeader; 
	  	
	  	//get intensity for lastGoal	   	   
	   	edu.udo.cs.ie.cowbots.planer.getIntensityForLastGoal(MyGoalIntensity);
	   	.concat("Helper Intensity for my goal: ",MyGoalIntensity,MMsg1);	   	
	   	!debugPrint(MMsg1);	    
	   	.send(Leader, tell, ack(Task, Cow, MyGoalIntensity, Wtime));
	   	!debugPrint("ack an Leader gesendet, warte auf rejected oder accepted");	   
	   	
	   	// wait until reject or accepted arrives	   
	   	!waitForAOR(Leader, Task, Cow, AckTime);
	   	-myleader(_);
	   	+myleader(Leader);
	   	!debugPrint("Accepted, wait till group is formed");
	   	//wait until leader sais group is formed
	   	!waitForGroupFormedByLeader(Leader, Task, Cow, GroupFormedTime);
	   	//wait until leader communicates information about herd to drive
	   	!debugPrint("waiting for herd information");
	   	!waitForHerdInformation(Cow, Leader);
	   	
	   	//walk to leader and send +iamarrived(_);
	   	!goToYourLeader(Leader);
	   	//NOW as separate intention	
	   	!debugPrint("Helper: arrived at Leader!");
	   	
	   	//still follow leader, till all agents in range   
	   	!!followLeader(Leader);
	   	!waitForAllAgentsInRange;
	   	.succeed_goal(followLeader(_));
	   
	   	//drive the cow (herd) to our corral
	   	!debugPrint("Helper: Started to drive the cow");	   
	   	!tryToDriveWithLeader(Leader, Task, Cow).

-!helped(Leader, T, Cow):	true
	<-	!debugPrint("HELPER GOAL ERROR!").  
	   
+!tryToDriveWithLeader(Leader, Task, Cow):	restarted
    <-	.send(Leader, tell, tryagainL);
      	.abolish(wp(_, _, _, _, _, _,_, _, _, _, _, _));
      	.abolish(getinformation(_,_));
      	-step(_);
	  	+step(0);
	  	!debugPrint("Helper: ReStarted driving the cow");
      	!groupDriving(Leader, Task, Cow);     
      	!tryToDriveWithLeader(Leader, Task, Cow).
      
+!tryToDriveWithLeader(Leader, Task, Cow):	not restarted
    <-	-step(_);
	  	+step(0);
	  	+restarted;
	  	!debugPrint("Helper: Started driving the cow");
      	!groupDriving(Leader, Task, Cow);     
      	!tryToDriveWithLeader(Leader, Task, Cow).

//soft reset.      
+tryagainH 
	<-	.succeed_goal(groupDriving(_,_,_)).               
	   
//wait till leader send allhelperinrange	   
+!waitForAllAgentsInRange:	not allhelpersinrange 
	<-	.wait(10000);
		!waitForAllAgentsInRange.
+!waitForAllAgentsInRange:	allhelpersinrange 
	<-	true. 
   
//wait until leader comunicates information about herd to drive	  
+!waitForHerdInformation(Obj, Leader):	not herd(Obj,Radius,_)[source(Leader)]  
	<-	.wait("+herd(Obj, Radius, _)",20000);
  		!debugPrint("Herd information is not there").	
  
+!waitForHerdInformation(Obj, Leader):	herd(Obj,Radius,_)[source(Leader)]  
	<-	!debugPrint("Herd information was  allready there").	
 
//drive the cow (herd) to our corral 
+!groupDriving(Leader, Task, Obj):	true
	<-	!getSubgoal(Leader, Task, Obj, WPTime);
	   	?step(Step);
	   	?wp(Leader, WPType, T, Obj, Step, X,Y, FromDirection, ToDirection, Formationpos, AgentsCount, Time);	   
	   	!debugPrint("WP- Check in group Driving succeded");
	   	?herd(Obj,Radius,_)[source(Leader)];
	   /**	 	   	
	   TODO: we just walk to position after rotate
	   !getMyNextPosition(drivenCow, X, Y, FromDirection, ToDirection, Formationpos, AgentsCount, Radius);
	   //laufe zu dieser Position 
	   ?myNextPositionCoordinates(Xd,Yd);
	   .concat("Helper: Walk to my position-befor rotate: x=",Xd," y=",Yd,Msd);
	   !debugPrint(Msd);
	   //todo, walking blub auslagern	
	   !setWalkingModi(1,0,1);	
	   -walkingfailed;   
	   !walkTo(Xd,Yd);
	   
	   // angekommen an der position	   	   
	   .my_name(MyName);
	   ?time(WPArivedTime);	   
	   .send(Leader, tell, inposition(Step, WPArivedTime));
	   !debugPrint("Warte auf getInFormation from Leader");
	   !waitLeaderSaysGetInFormation;
	   */
	  // .wait("+getinformation(Leader, Step, FormationTime)",20000);	   
	   	// alle in Formation, drehe die Formation wenn n�tig. 
	   
	   	!getMyNextPosition(rotateFormation, X, Y, FromDirection, ToDirection, Formationpos, AgentsCount, Radius);
	 
		//go to my position in formation 
	   	?myNextPositionCoordinates(Xr,Yr);
	  	.concat("Helper: taking position-afterRotate: x=",Xr," y=",Yr,Msr);
	   	!debugPrint(Msr);
	   	
	   	!setWalkingModi(1,0,1);	
	   	-walkingfailed;
	 	-walkfailscount(_);
        +walkfailscount(0);
	   	!walkTo(Xr,Yr);	 
	   	
	   	?iam(MyName);
	   	?time(AfterRotateTime);	
	   	.send(Leader, tell, information(Step, AfterRotateTime));	   
	   	NextStep=Step+1;
	   	-wp(Leader, WPType, T, Obj, Step, X,Y, FromDirection, ToDirection, Formationpos, AgentsCount, Time);
	   	-step(_);
	   	+step(NextStep);
	   	-getinformation(_,_);
	   	!groupDriving(Leader, Task, Obj).
	   
-!groupDriving(_, _,_) :	true 
	<-	!debugPrint("Helper: GroupDriving failed, try again").	   

// no problems, no solving
+!problemSolved(Task):	true
	<-	true.

//wait until leader sends getinformation
+!waitLeaderSaysGetInFormation:	getinformation(Step, FormationTime)[source(Leader)] 
	<-	true.
      
+!waitLeaderSaysGetInFormation:	not getinformation(Step, FormationTime)[source(Leader)]  
	<-	!debugPrint("Helper: wait until leader sends getinformation");
        .wait(10000);
        !waitLeaderSaysGetInFormation.
    
// wait until reject or accepted arrives

+!waitForAOR(Leader, Task, Obj, AckTime):	not helpAcceptedOrRequested(Leader, Task, Obj, AckTime)  
	<-	.wait(10000);
     	!waitForAOR(Leader, Task, Obj, AckTime).
     
 +!waitForAOR(Leader, Task, Obj, AckTime): helpAcceptedOrRequested(Leader, Task, Obj, AckTime)  
 	<-	//!debugPrint("helpAcceptedOrRequested ist bereits da");      
     	//check accepted or requested 
     	!debugPrint("helpAcceptedOrRequested succeded"). 
        
-!waitForAOR(Leader, Task, Obj, AckTime) :	true 
	<-	!debugPrint("helpAcceptedOrRequested failed");                  
        !taskabortHelper.    

+accepted(Task, Obj, Time)[source(Leader)]:	true 
	<-	.concat("Accepted von ",Leader ," fuer ",Task," ,Obj= ",Obj, " ist eingegangen um ", Time,Msg); 
  		!debugPrint(Msg);
  		+helpAcceptedOrRequested(Leader, Task, Obj, Time).
  
//drop the goal, leader sended rejected
+rejected(Task, Obj, Time)[source(Leader)]:	true	
	<-	.concat("Rejected von ",Leader ," fuer ",Task," ,Obj= ",Obj, " ist eingegangen um ", Time,Msg); 
        !debugPrint(Msg); 
        +taskabortHelper.
         
+rejectedall(Task, Obj, Time)[source(Leader)]:	myleader(Leader) 
	<-	.concat("RejectedAll von ",Leader ," fuer ",Task," ,Obj= ",Obj, " ist eingegangen um ", Time,Msg); 
        !debugPrint(Msg);
        !taskabortHelper.
          
+rejectedall(Task, Obj, Time)[source(Leader)]:	not myleader(Leader) 
	<-	.concat("RejectedAll von ",Leader ," fuer ",Task," ,Obj= ",Obj, " ist eingegangen um, ich helfe ihm aber gar nicht, also mache ich weiter mit help ", Time,Msg); 
        !debugPrint(Msg).

// wait until group is formed
+!waitForGroupFormedByLeader(Leader, Task, Obj, GroupFormedTime):	not groupformed(Task, Obj, _)[source(Leader)]
	<-	!debugPrint("WaitingForGroupFormedByLeader started");
     	.wait("+groupformed(TaskC, ObjC, GroupFormedTimeC)[source(LeaderC)]", 20000 );       
     	Leader=LeaderC;     
     	Task=TaskC; 
     	Obj=ObjC ;
     	GroupFormedTime=GroupFormedTimeC;
     	!debugPrint("waitForGroupFormedByLeader succeded").
 
+!waitForGroupFormedByLeader(Leader, Task, Obj, GroupFormedTime):	groupformed(Task, Obj, _)
	<-	true.
      
-!waitForGroupFormedByLeader(Leader, Task, Obj, GroupFormedTime):	true 
	<-	!debugPrint("waitForGroupFormedByLeader failed, try again");
        !waitForGroupFormedByLeader(Leader, Task, Obj, GroupFormedTime).

+groupformed(Leader, Task, Obj, GroupFormedTime):	true 
	<-	!debugPrint("have got groupFormed from Leader").
       
// wait till leader send current waypoint
											
+!getSubgoal(Leader, Task, Obj, WPTime) :	step(Step) & 
    										not wp(Leader, Type, Task, Obj, Step, XCoord,YCoord, FromDirection, ToDirection, Formationpos, AgentsCount, _)
	<-	!debugPrint("Helper: Wait for next waypoint");
    	skip; 
    	.wait(5000);
		//.wait("+defaultwp(LeaderC, TaskC, ObjC, Step, XCoord, YCoord, FromDirection, ToDirection, Formationpos, AgentsCount, WPTimeC)", 20000);
		!getSubgoal(Leader, Task, Obj, WPTime).

+!getSubgoal(Leader, Task, Obj, WPTime):	step(Step) & 
    										wp(Leader, Type, Task, Obj, Step, XCoord,YCoord, FromDirection, ToDirection, Formationpos, AgentsCount, _)
	<-	!debugPrint("Helper: waypoint allready in the BB").
   
-!getSubgoal(Leader, Task, Obj, WPTime):	true
	<-	!debugPrint("getSubgoal failed, try again"); 
    	!getSubgoal(Leader, Task, Obj, WPTime).

//spapstatus

+!swapStatus : (iAmNotBusy) <- -iAmNotBusy; +~iAmNotBusy.
+!swapStatus : (~iAmNotBusy) <- -~iAmNotBusy; +iAmNotBusy.

  
 +!getMyNextPosition(T, XCoord, YCoord, FromDirection, ToDirection, Formationpos, AgentsCount, Radius):	true 
	<-	edu.udo.cs.ie.cowbots.planer.getMyNextPositionsCoordinates(T, XCoord, YCoord, FromDirection, ToDirection, Formationpos, AgentsCount, Radius, MyNextXCoordinate, MyNextYCoordinate); 
       	-myNextPositionCoordinates;
       	.concat("Mine coordinates in formation are: ",MyNextXCoordinate ," : ",MyNextYCoordinate, Msg); 
       	!debugPrint(Msg); 
       	-myNextPositionCoordinates(_,_);
       	+myNextPositionCoordinates(MyNextXCoordinate,MyNextYCoordinate). 
 
 -!executedMonitored(GeneratedPlan) :	true 
 	<-	!debugPrint("executedMonitored failed");     
    	true. 

//walk to leader, send +iamarrived(_);
+!goToYourLeader(Leader):	leaderIsOn(Leader, X, Y,_) & 
        					.my_name(MyName)&
    						ison(MyName, Xm, Ym,_) &
        					edu.udo.cs.ie.cowbots.internalActions.Helper.arrivedAtLeader(X,Y,Xm,Ym,Distance)&
        					Distance < 7 
	<-	!debugPrint("Helper: i am arrived at Leader");
        .my_name(MyName);      
        .send(Leader, tell, iamarrived(MyName)).
                 
+!goToYourLeader(Leader): 	leaderIsOn(Leader, X, Y,_) & 
      						.my_name(MyName)&
      						ison(MyName, Xm, Ym,_) &
      						edu.udo.cs.ie.cowbots.internalActions.Helper.arrivedAtLeader(X,Y,Xm,Ym,Distance)&
        					Distance >= 7
	<-	!debugPrint("Helper: i am running to my Leader");
      	.abolish(leaderIsOn(_,_,_,_));
      	!tryToWalktoLeader(X,Y);      
      	!goToYourLeader(Leader).

         
+!goToYourLeader(Leader):	true        
	<-	!debugPrint("Helper: i have no idea where my Leader is, waiting");
        .wait(3000);
        !goToYourLeader(Leader).

//in case walking failes, we evtl. doesnt need to interupt the big plan                 
+!tryToWalktoLeader(X,Y) : 	true 
	<-	!setWalkingModi(1,0,1);	
	  	-walkingfailed;   	  
      	!walkTo(X,Y).
      
-!tryToWalktoLeader(X,Y):	true 
	<-	.wait(1000).
                                 
//-!goToYourLeader(Leader):true <- !goToYourLeader(Leader).  
               
  
//follow the leader till allhelpersinrange in bb  

+!followLeader(Leader):	not allhelpersinrange & 
						leaderIsOn(Name, X, Y, _) 
	<-	.concat("Helper: follow my leader at: x=", X," y=" ,Y, Msg1);
        !debugPrint(Msg1);  
        .abolish(leaderIsOn(_,_,_,_));
        !tryToWalktoLeader(X,Y);           
       .wait(1000);
       !followLeader(Leader).
           
+!followLeader(Leader)  : allhelpersinrange 
	<-	.concat("Helper: Cancel following the Leader", Msg1);
        !debugPrint(Msg1).          
           
+!followLeader(Leader):	true        
 	<-	!debugPrint("Helper: i have no idea where my Leader is, waiting");
		.wait(5000);
        !followLeader(Leader). 
                          
//-!followLeader(Leader) : true <-  !followLeader(Leader).  
// task abort handling
                                    
+!taskabortHelper:	myleader(Leader) 
	<-	.concat("Cancel Helperrole: ", Msg); 
        !debugPrint(Msg);   
	    .abolish(help(_,_,_,_));                                    
	    .abolish(herd(_,_,_));
    	.abolish(helpAcceptedOrRequested(_,_,_,_));
    	// .abolish(rejected(_,_,_,_));
     	.abolish(accepted(_,_,_));  
     	.abolish(getinformation(_,_));
     	.abolish(myNextPositionCoordinates(_,_));
     	.abolish(wp(_, _, _, _, _, _,_, _, _, _, _, _));
      	?time(Time);
      	.my_name(MyName);
      	.send(Leader, tell, planfailure(drivencow, Time));                                
	  	-myleader(_);
      	-restarted;
      	-allhelpersinrange;
     	.succeed_goal(followLeader(_));
     	.succeed_goal(helped(_,_,_)).
                                     
+!taskabortHelper:	not myleader(Leader)
	<-	.concat("Cancel Helperrole, no need for Leader notification", Msg); 
		!debugPrint(Msg);   
		.abolish(help(_,_,_,_));                                    
		.abolish(herd(_,_,_));
		.abolish(helpAcceptedOrRequested(_,_,_,_));
		.abolish(wp(_, _, _, _, _, _,_, _, _, _, _, _));
		// .abolish(rejected(_,_,_,_));
		.abolish(accepted(_,_,_,_));  
		.abolish(getinformation(_,_));
		.abolish(myNextPositionCoordinates(_,_));
		-allhelpersinrange;
		-restarted;
		.succeed_goal(followLeader(_));
		.succeed_goal(helped(_,_,_)).
                                                                                                
-taskabortHelper:	true
	<-	.concat("Cancel of Helperrole failed", Msg); 
		!debugPrint(Msg).    
 