// Walking to some coordinates
/* Initial beliefs and rules */
walkfailscount(0).
walkingfailstolerance(3).


/* Initial goals */


/* Plans */

+!debugPrint(D): debug <-
      ?iam(MyName);
     .concat("ASL-DEBUG: Agent:",MyName," MSG: ",D,MSG);	
	.print(MSG).
+!debugPrint(D): not debug <- .wait(1).

	
+!scoutWalkTo(X, Y, FenceParam):  iam(MyName) & ison(MyName,X,Y,_)     
   <-
   -distanceToCP(_);       
   .concat("Position ist schon erreicht, es gibt keinen Grund auf der Stelle zu laufen! ", Msg2);
   !debugPrint(Msg2).
   
   
+!scoutWalkTo(X, Y, FenceParam): 
    not walkingfailed 
    & distanceToCP(Dis) 
	& Dis < 3 
   <-    
   -distanceToCP(_);
   .concat("Position ist nahe genug dran, beende Lauferei ", Msg2a);
   !debugPrint(Msg2a).
   
   
+!scoutWalkTo(X, Y,FenceParam): 
    not walkingfailed 
    & walkfailscount(FailesCount) 
    & walkingfailstolerance(Maxfailes)
    & FailesCount<=Maxfailes    
   <- 
   
   .concat("Starte einen walking step", Msg1);
   !debugPrint(Msg1);
   !scoutDoOneStep(X,Y,FenceParam);  
   .concat("Ende von einem walking step, aktuelle Anzahl der Fehler ",FailesCount, Msg2);
   !debugPrint(Msg2);
   !scoutWalkTo(X, Y,FenceParam).
        
+!scoutWalkTo(X, Y,FenceParam):  walkingfailed
<-
 -distanceToCP(_);
 -walkingfailed;
 .fail. 
           
+!scoutDoOneStep(X,Y,FenceParam)  : true 
       <- 
          ?iam(MyName); 
          ?ison(MyName,X1,Y1,_);
          ?time(T);  
          edu.udo.cs.ie.cowbots.internalActions.scout.astar(X1,Y1,X,Y,A,T,0,FenceParam,1);
         .concat("Walking action is: ", A, Msg1);
         !debugPrint(Msg1);
         .concat("Versuche Aktion ",A, " auszufuehren", Msg2);
         !debugPrint(Msg2);
          A;
         !sendPosInfo(MyName);
         .concat("Aktion ",A, " ausgefuehrt", Msg3);
         !debugPrint(Msg3);
          edu.udo.cs.ie.cowbots.internalActions.scout.distanceToCP(X1,Y1,X,Y,Dis);
          -+distanceToCP(Dis);
          edu.udo.cs.ie.cowbots.internalActions.getExpectedCoordinates(X1, Y1, A, ExpX, ExpY);
          .concat("Erwartete Position x=",ExpX, " y=", ExpY, Msg4);
          !debugPrint(Msg4);
          ?ison(MyName,ActX,ActY,_);
          .concat("Tatsaechliche Position x=",ActX, " y=", ActY,Msg5);
          !debugPrint(Msg5);
          ?ison(MyName,ExpX, ExpY,_);        
         .concat("Position getestet, ein Schritt hat sowas von geklappt!",Msg6);
         !debugPrint(Msg6);
         -walkfailscount(_);
         +walkfailscount(0).

+!sendPosInfo(MyName) : helper(LN, MyName,_) 
<-
  !debugPrint("sendPosInfo(MyName) : helper(LN, MyName,_)");
   ?ison(MyName,X2,Y2,_);
   ?helper(LN, MyName,_);
   .send(LN, tell, helperOn(X2,Y2)).
           
+!sendPosInfo(MyName) : true
<-
  !debugPrint("sendPosInfo(MyName) : true").
          
         
-!scoutDoOneStep(X,Y,FenceParam) : not walkingfailed
	& walkfailscount(0)
	& distanceToCP(Dis) 
	& Dis < 3
	<-
      !debugPrint("scoutDoOneStep failed, but near enough to the WP").
	         
            
-!scoutDoOneStep(X,Y,FenceParam) : not walkingfailed 
       & walkfailscount(FailesCount) 
       & walkingfailstolerance(Maxfailes)
       & FailesCount<Maxfailes   
      <- 
        .concat("ein Schritt hat nicht geklappt, aktuelle Anzahl der Fehler war ", FailesCount,Msg1);
        !debugPrint(Msg1);
        NewFailesCount=FailesCount+1;
        -walkfailscount(_);
        +walkfailscount(NewFailesCount).
        
 -!scoutDoOneStep(X,Y,FenceParam) :
         walkfailscount(FailesCount) 
       & walkingfailstolerance(Maxfailes)
       & FailesCount>=Maxfailes   
      <- 
        .concat("ein Schritt hat nicht geklappt, und die Anzahl der Fehler wurde ueberschritten",Msg1);
        !debugPrint(Msg1);       
        -walkfailscount(_);
        +walkfailscount(0);
        +walkingfailed .
                   
  
     
 